Index: /palm/trunk/SOURCE/surface_coupler.f90
===================================================================
--- /palm/trunk/SOURCE/surface_coupler.f90	(revision 666)
+++ /palm/trunk/SOURCE/surface_coupler.f90	(revision 667)
@@ -5,4 +5,10 @@
 ! -----------------
 ! 
+! additional case for nonequivalent processor and grid topopolgy in ocean and 
+! atmosphere added (coupling_topology = 1)
+!
+! 
+! Added exchange of u and v from Ocean to Atmosphere
+!
 !
 ! Former revisions:
@@ -39,8 +45,11 @@
 
     REAL    ::  time_since_reference_point_rem
+    REAL    ::  total_2d(-nbgp:ny+nbgp,-nbgp:nx+nbgp)
 
 #if defined( __parallel )
 
-       CALL cpu_log( log_point(39), 'surface_coupler', 'start' )
+    CALL cpu_log( log_point(39), 'surface_coupler', 'start' )
+
+
 
 !
@@ -51,8 +60,25 @@
 !-- If necessary, the coupler will be called at the beginning of the next 
 !-- restart run.
-    CALL MPI_SENDRECV( terminate_coupled,        1, MPI_INTEGER, target_id,  &
-                       0, &
-                       terminate_coupled_remote, 1, MPI_INTEGER, target_id,  &
-                       0, comm_inter, status, ierr )
+
+    IF ( coupling_topology == 0 ) THEN
+       CALL MPI_SENDRECV( terminate_coupled,        1, MPI_INTEGER, target_id,  &
+                          0,                                                    &
+                          terminate_coupled_remote, 1, MPI_INTEGER, target_id,  &
+                          0, comm_inter, status, ierr )
+    ELSE
+       IF ( myid == 0) THEN
+          CALL MPI_SENDRECV( terminate_coupled,        1, MPI_INTEGER, &
+                             target_id, 0,                             &
+                             terminate_coupled_remote, 1, MPI_INTEGER, & 
+                             target_id, 0,                             &
+                             comm_inter, status, ierr )
+       ENDIF
+       CALL MPI_BCAST( terminate_coupled_remote, 1, MPI_INTEGER, 0, comm2d, ierr)
+
+       ALLOCATE( total_2d_a(-nbgp:ny_a+nbgp,-nbgp:nx_a+nbgp),       &
+                 total_2d_o(-nbgp:ny_o+nbgp,-nbgp:nx_o+nbgp) )
+
+    ENDIF
+
     IF ( terminate_coupled_remote > 0 )  THEN
        WRITE( message_string, * ) 'remote model "',                         &
@@ -64,81 +90,298 @@
                                   '" has',                                  &
                                   '&terminate_coupled = ',                  &
-                                  terminate_coupled
+                                   terminate_coupled
        CALL message( 'surface_coupler', 'PA0310', 1, 2, 0, 6, 0 )
        RETURN
     ENDIF
+ 
 
 !
 !-- Exchange the current simulated time between the models,
-!-- currently just for testing
-    CALL MPI_SEND( time_since_reference_point, 1, MPI_REAL, target_id, 11, &
-                   comm_inter, ierr )
-    CALL MPI_RECV( time_since_reference_point_rem, 1, MPI_REAL, target_id, 11, &
-                   comm_inter, status, ierr )
+!-- currently just for total_2ding
+    IF ( coupling_topology == 0 ) THEN   
+       CALL MPI_SEND( time_since_reference_point, 1, MPI_REAL, &
+                      target_id, 11, comm_inter, ierr )
+       CALL MPI_RECV( time_since_reference_point_rem, 1, MPI_REAL, &
+                      target_id, 11, comm_inter, status, ierr )
+    ELSE
+       IF ( myid == 0 ) THEN
+          CALL MPI_SEND( time_since_reference_point, 1, MPI_REAL, &
+                         target_id, 11, comm_inter, ierr )
+          CALL MPI_RECV( time_since_reference_point_rem, 1, MPI_REAL, &
+                         target_id, 11, comm_inter, status, ierr )
+       ENDIF
+       CALL MPI_BCAST( time_since_reference_point_rem, 1, MPI_REAL, &
+                       0, comm2d, ierr )
+    ENDIF
     WRITE ( 9, * ) 'simulated time: ', simulated_time
     WRITE ( 9, * ) 'time since start of coupling: ', &
-                   time_since_reference_point, ' remote: ', &
-                   time_since_reference_point_rem
-    CALL local_flush( 9 )
+                  time_since_reference_point, ' remote: ', &
+                  time_since_reference_point_rem
+   CALL local_flush( 9 )
+  
 
 !
 !-- Exchange the interface data
     IF ( coupling_mode == 'atmosphere_to_ocean' )  THEN
-
-!
-!--    Send heat flux at bottom surface to the ocean model
-       WRITE ( 9, * )  '*** send shf to ocean'
-       CALL local_flush( 9 )
-       CALL MPI_SEND( shf(nys-1,nxl-1), ngp_xy, MPI_REAL, target_id, 12, &
-                      comm_inter, ierr )
-
-!
-!--    Send humidity flux at bottom surface to the ocean model
-       IF ( humidity )  THEN
-          WRITE ( 9, * )  '*** send qsws to ocean'
+    
+!
+!--    Horizontal grid size and number of processors is equal
+!--    in ocean and atmosphere
+       IF ( coupling_topology == 0 ) THEN
+
+!
+!--       Send heat flux at bottom surface to the ocean model
+          CALL MPI_SEND( shf(nysg,nxlg), ngp_xy, MPI_REAL, &
+                         target_id, 12, comm_inter, ierr )
+
+!
+!--       Send humidity flux at bottom surface to the ocean model
+          IF ( humidity )  THEN
+             CALL MPI_SEND( qsws(nysg,nxlg), ngp_xy, MPI_REAL, &
+                            target_id, 13, comm_inter, ierr )
+          ENDIF
+
+!
+!--       Receive temperature at the bottom surface from the ocean model
+          WRITE ( 9, * )  '*** receive pt from ocean'
           CALL local_flush( 9 )
-          CALL MPI_SEND( qsws(nys-1,nxl-1), ngp_xy, MPI_REAL, target_id, 13, &
-               comm_inter, ierr )
+          CALL MPI_RECV( pt(0,nysg,nxlg), 1, type_xy, &
+                         target_id, 14, comm_inter, status, ierr )
+
+!
+!--       Send the momentum flux (u) at bottom surface to the ocean model
+          CALL MPI_SEND( usws(nysg,nxlg), ngp_xy, MPI_REAL, &
+                         target_id, 15, comm_inter, ierr )
+
+!
+!--       Send the momentum flux (v) at bottom surface to the ocean model
+          CALL MPI_SEND( vsws(nysg,nxlg), ngp_xy, MPI_REAL, &
+                         target_id, 16, comm_inter, ierr )
+
+!
+!--       Receive u at the bottom surface from the ocean model
+          CALL MPI_RECV( u(0,nysg,nxlg), 1, type_xy, &
+                         target_id, 17, comm_inter, status, ierr )
+
+!
+!--       Receive v at the bottom surface from the ocean model
+          CALL MPI_RECV( v(0,nysg,nxlg), 1, type_xy, &
+                         target_id, 18,  comm_inter, status, ierr )
+
+!
+!--    Horizontal grid size or number of processors differs between 
+!--    ocean and atmosphere
+       ELSE
+      
+!
+!--       Send heat flux at bottom surface to the ocean model
+          total_2d_a = 0.0
+          total_2d = 0.0
+          total_2d(nys:nyn,nxl:nxr) = shf(nys:nyn,nxl:nxr)
+          CALL MPI_REDUCE( total_2d, total_2d_a, ngp_a, MPI_REAL, &
+                           MPI_SUM, 0, comm2d, ierr )
+          CALL interpolate_to_ocean(12)
+   
+!
+!--       Send humidity flux at bottom surface to the ocean model
+          IF ( humidity ) THEN
+             total_2d_a = 0.0
+             total_2d = 0.0
+             total_2d(nys:nyn,nxl:nxr) = qsws(nys:nyn,nxl:nxr)
+             CALL MPI_REDUCE( total_2d, total_2d_a, ngp_a, MPI_REAL, &
+                              MPI_SUM, 0, comm2d, ierr )
+             CALL interpolate_to_ocean(13)
+          ENDIF
+
+!
+!--       Receive temperature at the bottom surface from the ocean model
+          IF ( myid == 0 ) THEN
+             CALL MPI_RECV( total_2d_a(-nbgp,-nbgp), ngp_a, MPI_REAL, &
+                            target_id, 14, comm_inter, status, ierr )   
+          ENDIF
+          CALL MPI_BARRIER( comm2d, ierr )
+          CALL MPI_BCAST( total_2d_a(-nbgp,-nbgp), ngp_a, MPI_REAL, &
+                          0, comm2d, ierr )
+          pt(0,nysg:nyng,nxlg:nxrg) = total_2d_a(nysg:nyng,nxlg:nxrg)
+
+!
+!--       Send momentum flux (u) at bottom surface to the ocean model
+          total_2d_a = 0.0 
+          total_2d = 0.0
+          total_2d(nys:nyn,nxl:nxr) = usws(nys:nyn,nxl:nxr)
+          CALL MPI_REDUCE( total_2d, total_2d_a, ngp_a, MPI_REAL, &
+                           MPI_SUM, 0, comm2d, ierr )
+          CALL interpolate_to_ocean(15)
+
+!
+!--       Send momentum flux (v) at bottom surface to the ocean model
+          total_2d_a = 0.0
+          total_2d = 0.0
+          total_2d(nys:nyn,nxl:nxr) = vsws(nys:nyn,nxl:nxr)
+          CALL MPI_REDUCE( total_2d, total_2d_a, ngp_a, MPI_REAL, &
+                           MPI_SUM, 0, comm2d, ierr )
+          CALL interpolate_to_ocean(16)
+
+!
+!--       Receive u at the bottom surface from the ocean model
+          IF ( myid == 0 ) THEN
+             CALL MPI_RECV( total_2d_a(-nbgp,-nbgp), ngp_a, MPI_REAL, &
+                            target_id, 17, comm_inter, status, ierr )            
+          ENDIF
+          CALL MPI_BARRIER( comm2d, ierr )
+          CALL MPI_BCAST( total_2d_a(-nbgp,-nbgp), ngp_a, MPI_REAL, &
+                          0, comm2d, ierr )
+          u(0,nysg:nyng,nxlg:nxrg) = total_2d_a(nysg:nyng,nxlg:nxrg)
+   
+!
+!--       Receive v at the bottom surface from the ocean model
+          IF ( myid == 0 ) THEN
+             CALL MPI_RECV( total_2d_a(-nbgp,-nbgp), ngp_a, MPI_REAL, &
+                            target_id, 18, comm_inter, status, ierr )            
+          ENDIF
+          CALL MPI_BARRIER( comm2d, ierr )
+          CALL MPI_BCAST( total_2d_a(-nbgp,-nbgp), ngp_a, MPI_REAL, &
+                          0, comm2d, ierr )
+          v(0,nysg:nyng,nxlg:nxrg) = total_2d_a(nysg:nyng,nxlg:nxrg)
+
        ENDIF
 
-!
-!--    Receive temperature at the bottom surface from the ocean model
-       WRITE ( 9, * )  '*** receive pt from ocean'
-       CALL local_flush( 9 )
-       CALL MPI_RECV( pt(0,nys-1,nxl-1), 1, type_xy, target_id, 14, &
-                      comm_inter, status, ierr )
-
-!
-!--    Send the momentum flux (u) at bottom surface to the ocean model
-       WRITE ( 9, * )  '*** send usws to ocean'
-       CALL local_flush( 9 )
-       CALL MPI_SEND( usws(nys-1,nxl-1), ngp_xy, MPI_REAL, target_id, 15, &
-                      comm_inter, ierr )
-
-!
-!--    Send the momentum flux (v) at bottom surface to the ocean model
-       WRITE ( 9, * )  '*** send vsws to ocean'
-       CALL local_flush( 9 )
-       CALL MPI_SEND( vsws(nys-1,nxl-1), ngp_xy, MPI_REAL, target_id, 16, &
-                      comm_inter, ierr )
-
     ELSEIF ( coupling_mode == 'ocean_to_atmosphere' )  THEN
 
 !
-!--    Receive heat flux at the sea surface (top) from the atmosphere model
-       WRITE ( 9, * )  '*** receive tswst from atmosphere'
-       CALL local_flush( 9 )
-       CALL MPI_RECV( tswst(nys-1,nxl-1), ngp_xy, MPI_REAL, target_id, 12, &
-                      comm_inter, status, ierr )
-
-!
-!--    Receive humidity flux from the atmosphere model (bottom)
-!--    and add it to the heat flux at the sea surface (top)...
+!--    Horizontal grid size and number of processors is equal
+!--    in ocean and atmosphere
+       IF ( coupling_topology == 0 ) THEN
+!
+!--       Receive heat flux at the sea surface (top) from the atmosphere model
+          CALL MPI_RECV( tswst(nysg,nxlg), ngp_xy, MPI_REAL, &
+                         target_id, 12, comm_inter, status, ierr )
+
+
+!
+!--       Receive humidity flux from the atmosphere model (bottom)
+!--       and add it to the heat flux at the sea surface (top)...
+          IF ( humidity_remote )  THEN
+             CALL MPI_RECV( qswst_remote(nysg,nxlg), ngp_xy, MPI_REAL, &
+                            target_id, 13, comm_inter, status, ierr )
+
+          ENDIF
+
+!
+!--       Send sea surface temperature to the atmosphere model
+          CALL MPI_SEND( pt(nzt,nysg,nxlg), 1, type_xy, &
+                         target_id, 14, comm_inter, ierr )
+
+!
+!--       Receive momentum flux (u) at the sea surface (top) from the atmosphere
+!--       model
+          WRITE ( 9, * )  '*** receive uswst from atmosphere'
+          CALL local_flush( 9 )
+          CALL MPI_RECV( uswst(nysg,nxlg), ngp_xy, MPI_REAL, &
+                         target_id, 15, comm_inter, status, ierr )
+
+!
+!--       Receive momentum flux (v) at the sea surface (top) from the atmosphere
+!--       model
+          CALL MPI_RECV( vswst(nysg,nxlg), ngp_xy, MPI_REAL, &
+                         target_id, 16, comm_inter, status, ierr )
+
+!--       Send u to the atmosphere model
+          CALL MPI_SEND( u(nzt,nysg,nxlg), 1, type_xy, &
+                         target_id, 17, comm_inter, ierr )
+
+!
+!--       Send v to the atmosphere model
+          CALL MPI_SEND( v(nzt,nysg,nxlg), 1, type_xy, &
+                         target_id, 18, comm_inter, ierr )
+
+!
+!--    Horizontal gridsize or number of processors differs between 
+!--    ocean and atmosphere
+       ELSE
+
+!
+!--       Receive heat flux at the sea surface (top) from the atmosphere model
+          IF ( myid == 0 ) THEN
+             CALL MPI_RECV( total_2d_o(-nbgp,-nbgp), ngp_o, MPI_REAL, &
+                            target_id, 12, comm_inter, status, ierr )            
+          ENDIF
+          CALL MPI_BARRIER( comm2d, ierr )
+          CALL MPI_BCAST( total_2d_o(-nbgp,-nbgp), ngp_o, MPI_REAL, &
+                          0, comm2d, ierr)
+          tswst(nysg:nyng,nxlg:nxrg) = total_2d_o(nysg:nyng,nxlg:nxrg)
+
+!
+!--       Receive humidity flux at the sea surface (top) from the 
+!--       atmosphere model
+          IF ( humidity_remote ) THEN
+             IF ( myid == 0 ) THEN
+                CALL MPI_RECV( total_2d_o(-nbgp,-nbgp), ngp_o, MPI_REAL, &
+                               target_id, 13, comm_inter, status, ierr )            
+             ENDIF
+             CALL MPI_BARRIER( comm2d, ierr )
+             CALL MPI_BCAST( total_2d_o(-nbgp,-nbgp), ngp_o, MPI_REAL, &
+                             0, comm2d, ierr)
+             qswst_remote(nysg:nyng,nxlg:nxrg) = total_2d_o(nysg:nyng,nxlg:nxrg)
+          ENDIF
+
+!
+!--       Send surface temperature to atmosphere
+          total_2d_o = 0.0
+          total_2d = 0.0
+          total_2d(nys:nyn,nxl:nxr) = pt(nzt,nys:nyn,nxl:nxr)
+
+          CALL MPI_REDUCE(total_2d, total_2d_o, ngp_o, &
+                          MPI_REAL, MPI_SUM, 0, comm2d, ierr) 
+
+          CALL interpolate_to_atmos(14)
+
+!
+!--       Receive momentum flux (u) at the sea surface (top) from the 
+!--       atmosphere model
+          IF ( myid == 0 ) THEN
+             CALL MPI_RECV( total_2d_o(-nbgp,-nbgp), ngp_o, MPI_REAL, &
+                            target_id, 15, comm_inter, status, ierr )            
+          ENDIF
+          CALL MPI_BARRIER( comm2d, ierr )
+          CALL MPI_BCAST( total_2d_o(-nbgp,-nbgp), ngp_o, MPI_REAL, &
+                          0, comm2d, ierr)
+          uswst(nysg:nyng,nxlg:nxrg) = total_2d_o(nysg:nyng,nxlg:nxrg)
+
+!
+!--       Receive momentum flux (v) at the sea surface (top) from the 
+!--       atmosphere model
+          IF ( myid == 0 ) THEN
+             CALL MPI_RECV( total_2d_o(-nbgp,-nbgp), ngp_o, MPI_REAL, &
+                            target_id, 16, comm_inter, status, ierr )            
+          ENDIF
+          CALL MPI_BARRIER( comm2d, ierr )
+          CALL MPI_BCAST( total_2d_o(-nbgp,-nbgp), ngp_o, MPI_REAL, &
+                          0, comm2d, ierr)
+          vswst(nysg:nyng,nxlg:nxrg) = total_2d_o(nysg:nyng,nxlg:nxrg)
+
+!
+!--       Send u to atmosphere
+          total_2d_o = 0.0  
+          total_2d = 0.0
+          total_2d(nys:nyn,nxl:nxr) = u(nzt,nys:nyn,nxl:nxr)
+          CALL MPI_REDUCE(total_2d, total_2d_o, ngp_o, MPI_REAL, &
+                          MPI_SUM, 0, comm2d, ierr)  
+          CALL interpolate_to_atmos(17)
+
+!
+!--       Send v to atmosphere
+          total_2d_o = 0.0
+          total_2d = 0.0
+          total_2d(nys:nyn,nxl:nxr) = v(nzt,nys:nyn,nxl:nxr)
+          CALL MPI_REDUCE(total_2d, total_2d_o, ngp_o, MPI_REAL, &
+                          MPI_SUM, 0, comm2d, ierr)  
+          CALL interpolate_to_atmos(18)
+        
+       ENDIF
+
+!
+!--    Conversions of fluxes received from atmosphere
        IF ( humidity_remote )  THEN
-          WRITE ( 9, * )  '*** receive qswst_remote from atmosphere'
-          CALL local_flush( 9 )
-          CALL MPI_RECV( qswst_remote(nys-1,nxl-1), ngp_xy, MPI_REAL, &
-                         target_id, 13, comm_inter, status, ierr )
-
           !here tswst is still the sum of atmospheric bottom heat fluxes
           tswst = tswst + qswst_remote * 2.2626108e6 / 1005.0
@@ -146,9 +389,9 @@
           !/(rho_atm(=1.0)*c_p)
 !
-!--    ...and convert it to a salinity flux at the sea surface (top)
+!--        ...and convert it to a salinity flux at the sea surface (top)
 !--       following Steinhorn (1991), JPO 21, pp. 1681-1683:
 !--       S'w' = -S * evaporation / ( rho_water * ( 1 - S ) )
           saswst = -1.0 * sa(nzt,:,:) * qswst_remote /  &
-               ( rho(nzt,:,:) * ( 1.0 - sa(nzt,:,:) ) )
+                    ( rho(nzt,:,:) * ( 1.0 - sa(nzt,:,:) ) )
        ENDIF
 
@@ -156,29 +399,6 @@
 !--    Adjust the kinematic heat flux with respect to ocean density
 !--    (constants are the specific heat capacities for air and water)
-       !now tswst is the ocean top heat flux
+!--    now tswst is the ocean top heat flux
        tswst = tswst / rho(nzt,:,:) * 1005.0 / 4218.0
-
-!
-!--    Send sea surface temperature to the atmosphere model
-       WRITE ( 9, * )  '*** send pt to atmosphere'
-       CALL local_flush( 9 )
-       CALL MPI_SEND( pt(nzt,nys-1,nxl-1), 1, type_xy, target_id, 14, &
-                      comm_inter, ierr )
-
-!
-!--    Receive momentum flux (u) at the sea surface (top) from the atmosphere
-!--    model
-       WRITE ( 9, * )  '*** receive uswst from atmosphere'
-       CALL local_flush( 9 )
-       CALL MPI_RECV( uswst(nys-1,nxl-1), ngp_xy, MPI_REAL, target_id, 15, &
-                      comm_inter, status, ierr )
-
-!
-!--    Receive momentum flux (v) at the sea surface (top) from the atmosphere
-!--    model
-       WRITE ( 9, * )  '*** receive vswst from atmosphere'
-       CALL local_flush( 9 )
-       CALL MPI_RECV( vswst(nys-1,nxl-1), ngp_xy, MPI_REAL, target_id, 16, &
-                      comm_inter, status, ierr )
 
 !
@@ -187,4 +407,9 @@
        vswst = vswst / rho(nzt,:,:)
 
+
+    ENDIF
+
+    IF ( coupling_topology == 1 ) THEN
+       DEALLOCATE( total_2d_o, total_2d_a )
     ENDIF
 
@@ -193,3 +418,138 @@
 #endif
 
- END SUBROUTINE surface_coupler
+  END SUBROUTINE surface_coupler
+
+
+
+  SUBROUTINE interpolate_to_atmos(tag)
+
+    USE arrays_3d
+    USE control_parameters
+    USE grid_variables
+    USE indices
+    USE pegrid
+
+    IMPLICIT NONE
+
+  
+    INTEGER             ::  dnx, dnx2, dny, dny2, i, ii, j, jj
+    INTEGER, intent(in) ::  tag
+
+    CALL MPI_BARRIER( comm2d, ierr )
+
+    IF ( myid == 0 ) THEN
+
+! 
+!--    cyclic boundary conditions for the total 2D-grid
+       total_2d_o(-nbgp:-1,:) = total_2d_o(ny+1-nbgp:ny,:)
+       total_2d_o(:,-nbgp:-1) = total_2d_o(:,nx+1-nbgp:nx)
+
+       total_2d_o(ny+1:ny+nbgp,:) = total_2d_o(0:nbgp-1,:)
+       total_2d_o(:,nx+1:nx+nbgp) = total_2d_o(:,0:nbgp-1)
+
+!
+!--    Number of gridpoints of the fine grid within one mesh of the coarse grid
+       dnx = (nx_o+1) / (nx_a+1) 
+       dny = (ny_o+1) / (ny_a+1) 
+
+!
+!--    Distance for interpolation around coarse grid points within the fine grid 
+!--    (note: 2*dnx2 must not be equal with dnx)  
+       dnx2 = 2 * ( dnx / 2 )
+       dny2 = 2 * ( dny / 2 )
+
+       total_2d_a = 0.0
+!
+!--    Interpolation from ocean-grid-layer to atmosphere-grid-layer
+       DO  j = 0, ny_a
+          DO  i = 0, nx_a 
+             DO  jj = 0, dny2
+                DO  ii = 0, dnx2
+                   total_2d_a(j,i) = total_2d_a(j,i) &
+                                     + total_2d_o(j*dny+jj,i*dnx+ii)
+                ENDDO
+             ENDDO
+             total_2d_a(j,i) = total_2d_a(j,i) / ( ( dnx2 + 1 ) * ( dny2 + 1 ) )
+          ENDDO
+       ENDDO
+! 
+!--    cyclic boundary conditions for atmosphere grid
+       total_2d_a(-nbgp:-1,:) = total_2d_a(ny_a+1-nbgp:ny_a,:)
+       total_2d_a(:,-nbgp:-1) = total_2d_a(:,nx_a+1-nbgp:nx_a)
+       
+       total_2d_a(ny_a+1:ny_a+nbgp,:) = total_2d_a(0:nbgp-1,:)
+       total_2d_a(:,nx_a+1:nx_a+nbgp) = total_2d_a(:,0:nbgp-1)
+!
+!--    Transfer of the atmosphere-grid-layer to the atmosphere
+       CALL MPI_SEND( total_2d_a(-nbgp,-nbgp), ngp_a, MPI_REAL, &
+                      target_id, tag, comm_inter, ierr )
+
+    ENDIF
+
+    CALL MPI_BARRIER( comm2d, ierr )
+
+  END SUBROUTINE interpolate_to_atmos
+
+
+  SUBROUTINE interpolate_to_ocean(tag)
+
+    USE arrays_3d
+    USE control_parameters
+    USE grid_variables
+    USE indices
+    USE pegrid
+
+    IMPLICIT NONE
+
+    REAL                ::  fl, fr, myl, myr
+    INTEGER             ::  dnx, dny, i, ii, j, jj
+    INTEGER, intent(in) ::  tag
+
+    CALL MPI_BARRIER( comm2d, ierr )
+
+    IF ( myid == 0 ) THEN   
+
+!
+!      Number of gridpoints of the fine grid within one mesh of the coarse grid
+       dnx = ( nx_o + 1 ) / ( nx_a + 1 ) 
+       dny = ( ny_o + 1 ) / ( ny_a + 1 ) 
+
+! 
+!--    cyclic boundary conditions for atmosphere grid
+       total_2d_a(-nbgp:-1,:) = total_2d_a(ny+1-nbgp:ny,:)
+       total_2d_a(:,-nbgp:-1) = total_2d_a(:,nx+1-nbgp:nx)
+       
+       total_2d_a(ny+1:ny+nbgp,:) = total_2d_a(0:nbgp-1,:)
+       total_2d_a(:,nx+1:nx+nbgp) = total_2d_a(:,0:nbgp-1)
+!
+!--    Bilinear Interpolation from atmosphere-grid-layer to ocean-grid-layer
+       DO  j = 0, ny
+          DO  i = 0, nx
+             myl = ( total_2d_a(j+1,i)   - total_2d_a(j,i)   ) / dny
+             myr = ( total_2d_a(j+1,i+1) - total_2d_a(j,i+1) ) / dny
+             DO  jj = 0, dny-1
+                fl = myl*jj  + total_2d_a(j,i)  
+                fr = myr*jj  + total_2d_a(j,i+1)  
+                DO  ii = 0, dnx-1
+                   total_2d_o(j*dny+jj,i*dnx+ii) = ( fr - fl ) / dnx * ii + fl
+                ENDDO
+             ENDDO
+          ENDDO
+       ENDDO
+! 
+!--    cyclic boundary conditions for ocean grid
+       total_2d_o(-nbgp:-1,:) = total_2d_o(ny_o+1-nbgp:ny_o,:)
+       total_2d_o(:,-nbgp:-1) = total_2d_o(:,nx_o+1-nbgp:nx_o)
+
+       total_2d_o(ny_o+1:ny_o+nbgp,:) = total_2d_o(0:nbgp-1,:)
+       total_2d_o(:,nx_o+1:nx_o+nbgp) = total_2d_o(:,0:nbgp-1)
+       
+
+       CALL MPI_SEND( total_2d_o(-nbgp,-nbgp), ngp_o, MPI_REAL, &
+                      target_id, tag, comm_inter, ierr )
+
+    ENDIF
+
+    CALL MPI_BARRIER( comm2d, ierr )  
+
+  END SUBROUTINE interpolate_to_ocean
Index: /palm/trunk/SOURCE/time_integration.f90
===================================================================
--- /palm/trunk/SOURCE/time_integration.f90	(revision 666)
+++ /palm/trunk/SOURCE/time_integration.f90	(revision 667)
@@ -4,5 +4,6 @@
 ! Current revisions:
 ! -----------------
-! 
+! Calls of exchange_horiz are modified.
+! Adaption to slooping surface.
 !
 ! Former revisions:
@@ -94,5 +95,7 @@
 !-- determine and print out the run control parameters
     IF ( simulated_time == 0.0 )  CALL timestep
+
     CALL run_control
+
 
 !
@@ -126,5 +129,4 @@
 
        CALL cpu_log( log_point_s(10), 'timesteps', 'start' )
-
 !
 !--    Determine size of next time step
@@ -189,20 +191,20 @@
 !--       Exchange of ghost points (lateral boundary conditions)
           CALL cpu_log( log_point(26), 'exchange-horiz-progn', 'start' )
-          CALL exchange_horiz( u_p )
-          CALL exchange_horiz( v_p )
-          CALL exchange_horiz( w_p )
-          CALL exchange_horiz( pt_p )
-          IF ( .NOT. constant_diffusion       )  CALL exchange_horiz( e_p )
+          CALL exchange_horiz( u_p, nbgp )
+          CALL exchange_horiz( v_p, nbgp )
+          CALL exchange_horiz( w_p, nbgp )
+          CALL exchange_horiz( pt_p, nbgp )
+          IF ( .NOT. constant_diffusion )  CALL exchange_horiz( e_p, nbgp )
           IF ( ocean )  THEN
-             CALL exchange_horiz( sa_p )
-             CALL exchange_horiz( rho )
-             CALL exchange_horiz( prho )
-          ENDIF
-          IF ( humidity  .OR.  passive_scalar )  CALL exchange_horiz( q_p )
+             CALL exchange_horiz( sa_p, nbgp )
+             CALL exchange_horiz( rho, nbgp )
+             CALL exchange_horiz( prho, nbgp )
+          ENDIF
+          IF (humidity  .OR.  passive_scalar) CALL exchange_horiz( q_p, nbgp )
           IF ( cloud_droplets )  THEN
-             CALL exchange_horiz( ql )
-             CALL exchange_horiz( ql_c )
-             CALL exchange_horiz( ql_v )
-             CALL exchange_horiz( ql_vp )
+             CALL exchange_horiz( ql, nbgp )
+             CALL exchange_horiz( ql_c, nbgp )
+             CALL exchange_horiz( ql_v, nbgp )
+             CALL exchange_horiz( ql_vp, nbgp )
           ENDIF
 
@@ -228,6 +230,6 @@
 !--       when a sloping surface is used
           IF ( sloping_surface )  THEN
-             IF ( nxl ==  0 )  pt(:,:,nxl-1) = pt(:,:,nxl-1) - pt_slope_offset
-             IF ( nxr == nx )  pt(:,:,nxr+1) = pt(:,:,nxr+1) + pt_slope_offset
+             IF ( nxl ==  0 ) pt(:,:,nxlg:nxl-1) = pt(:,:,nxlg:nxl-1) - pt_slope_offset
+             IF ( nxr == nx )  pt(:,:,nxr+1:nxrg) = pt(:,:,nxr+1:nxrg) + pt_slope_offset
           ENDIF
 
@@ -563,4 +565,5 @@
        CALL cpu_log( log_point_s(10), 'timesteps', 'stop' )
 
+
     ENDDO   ! time loop
 
Index: /palm/trunk/SOURCE/timestep.f90
===================================================================
--- /palm/trunk/SOURCE/timestep.f90	(revision 666)
+++ /palm/trunk/SOURCE/timestep.f90	(revision 667)
@@ -4,5 +4,10 @@
 ! Current revisions:
 ! -----------------
-! 
+!
+!
+! Exchange of terminate_coupled between ocean and atmosphere via PE0
+!
+! Minimum grid spacing dxyz2_min(k) is now calculated using dzw instead of dzu
+!
 !
 ! Former revisions:
@@ -60,13 +65,15 @@
     REAL, DIMENSION(nzb+1:nzt) ::  dxyz2_min
 
+
+
     CALL cpu_log( log_point(12), 'calculate_timestep', 'start' )
 
 !
 !-- Determine the maxima of the velocity components.
-    CALL global_min_max( nzb, nzt+1, nys-1, nyn+1, nxl-1, nxr+1, u, 'abs', &
+    CALL global_min_max( nzb, nzt+1, nysg, nyng, nxlg, nxrg, u, 'abs', &
                          u_max, u_max_ijk )
-    CALL global_min_max( nzb, nzt+1, nys-1, nyn+1, nxl-1, nxr+1, v, 'abs', &
+    CALL global_min_max( nzb, nzt+1, nysg, nyng, nxlg, nxrg, v, 'abs', &
                          v_max, v_max_ijk )
-    CALL global_min_max( nzb, nzt+1, nys-1, nyn+1, nxl-1, nxr+1, w, 'abs', &
+    CALL global_min_max( nzb, nzt+1, nysg, nyng, nxlg, nxrg, w, 'abs', &
                          w_max, w_max_ijk )
 
@@ -152,5 +159,5 @@
 
        DO  k = nzb+1, nzt
-           dxyz2_min(k) = MIN( dx2, dy2, dzu(k)*dzu(k) ) * 0.125
+           dxyz2_min(k) = MIN( dx2, dy2, dzw(k)*dzw(k) ) * 0.125
        ENDDO
 
@@ -323,8 +330,11 @@
           IF ( coupling_mode /= 'uncoupled' .AND. terminate_coupled == 0 )  THEN
              terminate_coupled = 2
-             CALL MPI_SENDRECV( &
-                  terminate_coupled,        1, MPI_INTEGER, target_id,  0, &
-                  terminate_coupled_remote, 1, MPI_INTEGER, target_id,  0, &
-                  comm_inter, status, ierr )
+             IF ( myid == 0 ) THEN
+                CALL MPI_SENDRECV( &
+                     terminate_coupled,        1, MPI_INTEGER, target_id,  0, &
+                     terminate_coupled_remote, 1, MPI_INTEGER, target_id,  0, &
+                     comm_inter, status, ierr )
+             ENDIF
+             CALL MPI_BCAST( terminate_coupled_remote, 1, MPI_INTEGER, 0, comm2d, ierr)
           ENDIF
 #endif
Index: /palm/trunk/SOURCE/user_3d_data_averaging.f90
===================================================================
--- /palm/trunk/SOURCE/user_3d_data_averaging.f90	(revision 666)
+++ /palm/trunk/SOURCE/user_3d_data_averaging.f90	(revision 667)
@@ -41,5 +41,5 @@
 !          CASE ( 'u2' )
 !             IF ( .NOT. ALLOCATED( u2_av ) )  THEN
-!                ALLOCATE( u2_av(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
+!                ALLOCATE( u2_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
 !             ENDIF
 !             u2_av = 0.0
@@ -60,6 +60,6 @@
 !--       Sample for user-defined output:
 !          CASE ( 'u2' )
-!             DO  i = nxl-1, nxr+1
-!                DO  j = nys-1, nyn+1
+!             DO  i = nxlg, nxrg
+!                DO  j = nysg, nyng
 !                   DO  k = nzb, nzt+1
 !                      u2_av(k,j,i) = u2_av(k,j,i) + u2(k,j,i)
@@ -83,6 +83,6 @@
 !--       Sample for user-defined output:
 !          CASE ( 'u2' )
-!             DO  i = nxl-1, nxr+1
-!                DO  j = nys-1, nyn+1
+!             DO  i = nxlg, nxrg
+!                DO  j = nysg, nyng
 !                   DO  k = nzb, nzt+1
 !                      u2_av(k,j,i) = u2_av(k,j,i) / REAL( average_count_3d )
Index: /palm/trunk/SOURCE/user_actions.f90
===================================================================
--- /palm/trunk/SOURCE/user_actions.f90	(revision 666)
+++ /palm/trunk/SOURCE/user_actions.f90	(revision 667)
@@ -4,5 +4,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! nxl-1, nxr+1, nys-1, nyn+1 replaced by nxlg, nxrg, nysg, nyng.
 !
 ! Former revisions:
@@ -69,13 +69,13 @@
 !--          data output)
 !--          Sample for user-defined output:
-!             DO  i = nxl-1, nxr+1
-!                DO  j = nys-1, nyn+1
-!                   DO  k = nzb, nzt+1
+!             DO  i = nxlg, nxrg
+!                DO  j = nysg, nyng
+!                   DO  k = nzb, nzt
 !                      u2(k,j,i) = u(k,j,i)**2
 !                   ENDDO
 !                ENDDO
 !             ENDDO
-!             DO  i = nxl-1, nxr
-!                DO  j = nys-1, nyn
+!             DO  i = nxlg, nxr
+!                DO  j = nysg, nyn
 !                   DO  k = nzb, nzt+1
 !                      ustvst(k,j,i) =  &
Index: /palm/trunk/SOURCE/user_data_output_2d.f90
===================================================================
--- /palm/trunk/SOURCE/user_data_output_2d.f90	(revision 666)
+++ /palm/trunk/SOURCE/user_data_output_2d.f90	(revision 667)
@@ -4,5 +4,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! nxl-1, nxr+1, nys-1, nyn+1 replaced by nxlg, nxrg, nysg, nyng.
 !
 ! Former revisions:
@@ -34,5 +34,5 @@
     LOGICAL ::  found, two_d
 
-    REAL, DIMENSION(nxl-1:nxr+1,nys-1:nyn+1,nzb:nzt+1) ::  local_pf
+    REAL, DIMENSION(nxlg:nxrg,nysg:nyng,nzb:nzt+1) ::  local_pf
 
 
@@ -48,6 +48,6 @@
 !       CASE ( 'u2_xy', 'u2_xz', 'u2_yz' )
 !          IF ( av == 0 )  THEN
-!             DO  i = nxl-1, nxr+1
-!                DO  j = nys-1, nyn+1
+!             DO  i = nxlg, nxrg
+!                DO  j = nysg, nyng
 !                   DO  k = nzb, nzt+1
 !                      local_pf(i,j,k) = u2(k,j,i)
@@ -56,6 +56,6 @@
 !             ENDDO
 !          ELSE
-!             DO  i = nxl-1, nxr+1
-!                DO  j = nys-1, nyn+1
+!             DO  i = nxlg, nxrg
+!                DO  j = nysg, nyng
 !                   DO  k = nzb, nzt+1
 !                      local_pf(i,j,k) = u2_av(k,j,i)
